﻿Imports SciLorsGroovesharkAPI
Imports System.IO
Imports System.Data
Imports SciLorsGroovesharkAPI.Groove.Functions
Imports System.Threading
Imports System.Xml.Serialization
Imports System.Xml
Imports System.Reflection
Imports System.Net
Imports System.Globalization

Class MainWindow
    'private System.Windows.Forms.NotifyIcon m_notifyIcon;
    Private notifyIcon As Forms.NotifyIcon

    Public grooveClient As Groove.GroovesharkClient = Nothing
    Public grooveBitRateClient As Groove.GroovesharkClient = Nothing
    'Public FoundResults As New List(Of Groove.Functions.SearchArtist.SearchArtistResult)

    'Dim DownloadResults As New List(Of Groove.Functions.SearchArtist.SearchArtistResult)

    Dim DownloadEnabled As Boolean
    Dim DownloadItemID As Integer

    Dim FoundResults As New List(Of EnhancedResultGrid)
    Dim FoundResultsTable As DataTable = EnhancedResultGrid.ReturnEnhancedTable
    Dim DownloadResults As New List(Of ResultGrid)
    Dim DownloadResultsTable As DataTable = ResultGrid.ReturnBaseTable

    Dim CurrentSearch As String = ""
    Dim DownloadResultsPath As String = Path.Combine(Utilities.GetAppPath(), "DownloadResults.xml")

    Dim ContextMenuRowId As Integer = 1
    Dim dagSearchContextMenu As ContextMenu
    Dim dagSearchContextMenuSongOnGrooveshark As TextBlock
    Dim dagSearchContextMenuGetBitrate As TextBlock
    Dim dagSearchContextMenuArtistResults As TextBlock
    Dim dagSearchContextMenuAlbumResults As TextBlock
    Dim dagSearchContextMenuSelect As TextBlock
    Dim dagSearchContextMenuDeselect As TextBlock

    Dim isDebug As Boolean
    Dim autocompleteEnabled As Boolean = True

    Dim TempProxy As String
    Dim UseTor As Boolean
    Dim TorProblem As Boolean

    Private Delegate Sub TextDelegate(ByVal Text As String)

    Public Shared Sub DoEvents(ByVal dispatch As Windows.Threading.Dispatcher)
        If dispatch IsNot Nothing Then
            dispatch.Invoke(New Action(AddressOf DoEventsHandler), Windows.Threading.DispatcherPriority.Background)
        End If
    End Sub

    Private Shared Sub DoEventsHandler()

    End Sub

    Public Shared Function GetAppPathSpecial(Optional ByVal AppendPath As String = "", Optional ByVal AppendFile As String = "") As String
        Dim tempPath As String = Directory.GetParent(Assembly.GetExecutingAssembly().Location).FullName

        If Not AppendPath = "" Then
            tempPath = Path.Combine(tempPath, AppendPath)
        End If
        If Not AppendFile = "" Then
            tempPath = Path.Combine(tempPath, AppendFile)
        End If

        Return tempPath
    End Function


    Private Sub loadXaml(ByVal Filename As String)
        Try
            Dim lang As String = File.ReadAllLines(GetAppPathSpecial("", "lang"))(0)
            Skin.loadLanguageXml(GetAppPathSpecial("Language", lang))
        Catch
            Skin.loadLanguageXml(GetAppPathSpecial("Language", ""))
        End Try

        If Not File.Exists(GetAppPathSpecial("Skins", Filename)) Then
            MsgBox(Skin.getLanguageText("LangSkinfileMissing", "Skinfile missing:") & " " & GetAppPathSpecial("Skins", Filename), Microsoft.VisualBasic.MsgBoxStyle.Critical, "Error!")
            Me.Close()
        End If
        Dim XamlData As String = File.ReadAllText(GetAppPathSpecial("Skins", Filename))

        Call WindowGrid.Children.Clear()
        CurrentSkin = Nothing

        CurrentSkin = XamlReader.Parse(XamlData)
        WindowGrid.Children.Add(CurrentSkin)

        Call SetControlVariables()
        Call SetControlEvents()
    End Sub

    Public Sub SetControlEvents()
        AddHandler mniCheckForUpdates.Click, AddressOf mniCheckForUpdates_Click
        AddHandler mniAvailableSoftware.Click, AddressOf mniAvailableSoftware_Click
        AddHandler mniSciLorsWebsite.Click, AddressOf mniSciLorsWebsite_Click
        AddHandler mniExit.Click, AddressOf mniExit_Click

        AddHandler mniReconnect.Click, AddressOf mniReconnect_Click
        AddHandler mniClearDownloadList.Click, AddressOf mniClearDownloadList_Click
        AddHandler mniGoToDownloadDir.Click, AddressOf mniGoToDownloadDir_Click

        AddHandler mniMazda.Click, AddressOf mniMazda_Click
        AddHandler mniGroovesharkGermany.Click, AddressOf mniGroovesharkGermany_Click
        AddHandler mniDonate.Click, AddressOf mniDonate_Click
        AddHandler mniFacebook.Click, AddressOf mniFacebook_Click

        'AddHandler mniHelp.Click, AddressOf mniHelp_Click
        AddHandler mniCommandLine.Click, AddressOf mniCommandLine_Click
        AddHandler mniDebugMode.Click, AddressOf mniDebugMode_Click
        AddHandler mniSupport.Click, AddressOf mniSupport_Click

        'Public txtSearch As TextBox
        AddHandler txtSearch.KeyUp, AddressOf txtSearch_KeyUp
        AddHandler txtSearch.TextChanged, AddressOf txtSearch_TextChanged
        AddHandler btnSearch.Click, AddressOf btnSearch_Click
        AddHandler btnPopularSongs.Click, AddressOf btnPopularSongs_Click

        AddHandler btnSelectAll.Click, AddressOf btnSelectAll_Click
        AddHandler btnDeselectAll.Click, AddressOf btnDeselectAll_Click
        AddHandler btnInvertSelection.Click, AddressOf btnInvertSelection_Click
        AddHandler btnAddToDownloadList.Click, AddressOf btnAddToDownloadList_Click
        AddHandler txtResultFilter.TextChanged, AddressOf txtResultFilter_TextChanged

        'Public pgbDownloadState As ProgressBar
        AddHandler btnDownload.Click, AddressOf btnDownload_Click
        AddHandler dagDownload.MouseLeftButtonUp, AddressOf dagDownload_MouseLeftButtonUp

        AddHandler btnBaseDir.Click, AddressOf btnBaseDir_Click
        AddHandler cmbPattern.SelectionChanged, AddressOf cmbPattern_TextChanged
        AddHandler cmbPattern.KeyUp, AddressOf cmbPattern_TextChanged
        AddHandler cmbPattern.MouseUp, AddressOf cmbPattern_TextChanged
        AddHandler cmbPattern.MouseWheel, AddressOf cmbPattern_TextChanged
        AddHandler cmbPattern.LostFocus, AddressOf cmbPattern_TextChanged
        AddHandler cmbPattern.ContextMenuClosing, AddressOf cmbPattern_TextChanged
        AddHandler cmbPattern.GotFocus, AddressOf cmbPattern_TextChanged
        AddHandler cmbPattern.QueryCursor, AddressOf cmbPattern_TextChanged
        AddHandler cmbPattern.MouseMove, AddressOf cmbPattern_TextChanged

        AddHandler btnProxyTest.Click, AddressOf btnProxyTest_Click

        AddHandler btnSave.Click, AddressOf btnSave_Click

        AddHandler btnBatchSearch.Click, AddressOf btnBatchSearch_Click
        AddHandler btnImportBatch.Click, AddressOf btnImportBatch_Click
        AddHandler txtLoginPass.KeyUp, AddressOf txtLoginPass_KeyUp
        AddHandler btnLoginFetchPlaylists.Click, AddressOf btnLoginFetchPlaylists_Click
        AddHandler btnFetchPlaylists.Click, AddressOf btnFetchPlaylists_Click
        AddHandler btnFetchPlaylistById.Click, AddressOf btnFetchPlaylistsById_Click

        'Public txtDebug As TextBox

        AddHandler dagSearch.MouseUp, AddressOf dagSearch_Click
        AddHandler dagSearch.SelectionChanged, AddressOf dagSearch_SelectionChanged
        AddHandler dagSearchContextMenuSongOnGrooveshark.MouseUp, AddressOf dagSearchContextMenuSongOnGrooveshark_Click
        AddHandler dagSearchContextMenuGetBitrate.MouseUp, AddressOf dagSearchContextMenuGetBitrate_Click
        AddHandler dagSearchContextMenuAlbumResults.MouseUp, AddressOf dagSearchContextMenuAlbumResults_Click
        AddHandler dagSearchContextMenuArtistResults.MouseUp, AddressOf dagSearchContextMenuArtistResults_Click
        AddHandler dagSearchContextMenuSelect.MouseUp, AddressOf dagSearchContextMenuSelect_Click
        AddHandler dagSearchContextMenuDeselect.MouseUp, AddressOf dagSearchContextMenuDeselect_Click
    End Sub

    Private langList As List(Of String)
    Private Sub LoadLanguageList()
        Dim i As Integer = 0
        langList = New List(Of String)
        mniLanguage.Items.Clear()

        Dim firstItem As New MenuItem()
        firstItem.Header = "English" & " (" & "English" & ")"
        firstItem.Name = "mniLanguageId" & i
        AddHandler firstItem.Click, AddressOf mniLanguageId_Click

        mniLanguage.Items.Add(firstItem)
        langList.Add("")

        Dim langDir As New DirectoryInfo(GetAppPathSpecial("Language"))
        For Each File As FileInfo In langDir.GetFiles("*.xml")
            i += 1
            Try
                Dim xml As New XmlDocument()
                xml.Load(File.FullName)
                If xml.FirstChild.Name = "SciLor" Then
                    Dim item As New MenuItem()
                    item.Header = xml.Item("SciLor").GetAttribute("english") & " (" & xml.Item("SciLor").GetAttribute("name") & ")"
                    item.Name = "mniLanguageId" & i
                    item.Tag = xml.Item("SciLor").GetAttribute("iso")

                    Dim icon As Image = New Image()
                    icon.Source = New BitmapImage(New Uri("Language\" & xml.Item("SciLor").GetAttribute("icon"), UriKind.Relative))
                    icon.Width = 16
                    icon.Height = 12
                    item.Icon = icon

                    AddHandler item.Click, AddressOf mniLanguageId_Click

                    mniLanguage.Items.Add(item)
                    langList.Add(File.Name)
                End If
            Catch ex As Exception
                AddDebug("Language file problem (""" & File.Name & """): " & ex.Message)
                langList = New List(Of String)
                mniLanguage.Items.Clear()
            End Try
        Next
    End Sub

    Private Sub mniLanguageId_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Dim LangId As MenuItem = TryCast(sender, MenuItem)
        Dim id As Integer = LangId.Name.Substring("mniLanguageId".Length)
        Try
            File.WriteAllText(GetAppPathSpecial("", "lang"), langList(id))
        Catch ex As UnauthorizedAccessException
            AdministrationRightsNeeded()
            Return
        End Try
        Call ExportAllDownloadResults()
        Call Window_Loaded(Nothing, Nothing)
    End Sub

    Private Sub MainWindow_Closed(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Closed
        Call ExportAllDownloadResults(False)
        notifyIcon.Visible = False
        StopTor()
        Application.Current.Shutdown()
    End Sub

    Public Sub toLog(ByVal Text As String)
        Console.WriteLine(Text)
    End Sub

    Private Sub ShowCommandLineHelp()
        MsgBox("Commandline options:" & vbNewLine & _
                                   "-help: This screen" & vbNewLine & _
                                   "-download: Starts downloading after startup" & vbNewLine & _
                                   "-search <query>: Searches for your query" & vbNewLine & _
                                   "-popular: Searches for popular songs after startup" & vbNewLine & _
                                   "-add <number/all/none>: Adds the download in the search box with the number 1-? or ""all""" & vbNewLine & _
                                   "-username <username>: Sets the username" & vbNewLine & _
                                   "-password <password>: Sets the password" & vbNewLine & _
                                   "-loginAndFetchPlaylists <number/name>: Adds the playlists to the search box with the number 1-?, its name or ""all""" & vbNewLine & _
                                   "-playlistById <id>: Adds a playlist to the searchbox" & vbNewLine & _
                                   "-clear: Clears the downloadlist" & vbNewLine & _
                                   "-batch <path to file>: Performs Batch Search & Add" & vbNewLine & _
                                   "-hide: Hides the Application (Taskbar)" & vbNewLine & _
                                   "-show: Shows the Application" & vbNewLine & _
                                   "-exit: Exits the Application" & vbNewLine & _
                                   "-proxy <ip:port>: Sets the proxy" & vbNewLine & _
                                   "-tempproxy <ip:port>: Sets the proxy, but does not save it." & vbNewLine & _
                                   "-tor: runs and manages tor." & vbNewLine & _
                                   "-debug: Debug mode" & vbNewLine & _
                                    vbNewLine & "The commandline options are executed one by one." _
                                   , vbOKOnly, Me.Title & " - " & "Commandline options")
    End Sub

    Private Sub Window_Loaded(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles MyBase.Loaded
        Try

            Dim args As String() = Environment.GetCommandLineArgs()
            If args.Length > 1 Then
                For I As Integer = 1 To args.Length - 1
                    Dim argument As String = args(I)
                    Select Case argument
                        Case "-help"
                            ShowCommandLineHelp()
                            Me.Close()
                        Case "-debug"
                            isDebug = True
                            log = New SciLors_Logger.Logger(Path.Combine(GetAppPath(), "SciLorsGrooveDownloader.log"), SciLors_Logger.Logger.LogLevel.ALL)
                            MsgBox("Starting Debug logging" & vbNewLine & "Please use this only if you got problems with this application", vbOKOnly, "Debug Mode")
                        Case "-hide"
                            Me.WindowState = Windows.WindowState.Minimized
                        Case "-proxy"
                            If args.Length > I + 1 Then
                                myConfig.Settings.Proxy = args(I + 1)
                                myConfig.Save()
                            End If
                        Case "-tempproxy"
                            I += 1
                            If args.Length > I Then
                                TempProxy = args(I)
                            End If
                        Case "-tor"
                            UseTor = True
                    End Select
                Next
            End If

            log.logInfo("Downloader Window_Loaded", "Version: " & myProgram.version)

            dagSearchContextMenu = New ContextMenu()
            dagSearchContextMenuSongOnGrooveshark = New TextBlock()
            dagSearchContextMenuGetBitrate = New TextBlock()
            dagSearchContextMenuAlbumResults = New TextBlock()
            dagSearchContextMenuArtistResults = New TextBlock()
            dagSearchContextMenuSelect = New TextBlock()
            dagSearchContextMenuDeselect = New TextBlock()

            dagSearchContextMenu.Items.Add(dagSearchContextMenuSongOnGrooveshark)
            dagSearchContextMenu.Items.Add(dagSearchContextMenuGetBitrate)
            dagSearchContextMenu.Items.Add(New Separator())
            dagSearchContextMenu.Items.Add(dagSearchContextMenuAlbumResults)
            dagSearchContextMenu.Items.Add(dagSearchContextMenuArtistResults)
            dagSearchContextMenu.Items.Add(New Separator())
            dagSearchContextMenu.Items.Add(dagSearchContextMenuSelect)
            dagSearchContextMenu.Items.Add(dagSearchContextMenuDeselect)

            Call StartUp(Me)

            Try
                Dim fp As String = Path.Combine(GetAppPath(), "access")
                If File.Exists(fp) Then
                    File.Delete(fp)
                End If
                File.WriteAllLines(fp, New String() {"access"})
                If Not File.Exists(fp) Then
                    AdministrationRightsNeeded()
                    Return
                End If
            Catch ex As UnauthorizedAccessException
                AdministrationRightsNeeded()
                Return
            End Try

                Call loadXaml("BaseSkin.xaml")

                Call LoadLanguageList()

                If Not File.Exists("lang") Then
                    Try
                        For i As Integer = 0 To mniLanguage.Items.Count - 1
                            Dim mi As MenuItem = mniLanguage.Items(i)
                            Dim iso As String = mi.Tag
                            If iso = CultureInfo.CurrentCulture.Name Or iso = CultureInfo.CurrentCulture.TwoLetterISOLanguageName Then
                                If MessageBox.Show("Set Language to " & mi.Header & "?", "Language", MessageBoxButton.YesNo, MessageBoxImage.Question, MessageBoxResult.Yes) = MessageBoxResult.Yes Then
                                    mniLanguageId_Click(mi, Nothing)
                                Else
                                    mniLanguageId_Click(mniLanguage.Items(0), Nothing)
                                End If
                                i = mniLanguage.Items.Count
                                Return
                            End If
                        Next
                    Catch
                    End Try
                End If

            If CultureInfo.CurrentCulture.Name = "de-DE" Then
                mniGroovesharkGermany.Visibility = Windows.Visibility.Visible
            End If
            If DateTime.Now.Month = 6 And DateTime.Now.Day < 17 And DateTime.Now.Year = 2012 Then
                mniMazda.Visibility = Windows.Visibility.Visible
            End If

                dagSearchContextMenuSongOnGrooveshark.Text = Skin.getLanguageText("LangDagSearchContextMenuSongOnGrooveshark", "Open song on Grooveshark(tm)")
                dagSearchContextMenuGetBitrate.Text = Skin.getLanguageText("LangDagSearchContextMenuGetBitrate", "Fetch Bitrate")
                dagSearchContextMenuAlbumResults.Text = Skin.getLanguageText("LangDagSearchContextMenuAlbumResults", "Search for Album")
                dagSearchContextMenuArtistResults.Text = Skin.getLanguageText("LangDagSearchContextMenuArtistResults", "Search for Artist")
                dagSearchContextMenuSelect.Text = Skin.getLanguageText("LangDagSearchContextMenuSelect", "Select")
                dagSearchContextMenuDeselect.Text = Skin.getLanguageText("LangDagSearchContextMenuDeselect", "Deselect")

                notifyIcon = New Forms.NotifyIcon()
                notifyIcon.BalloonTipText = "The app is minimized to the tray!"

                notifyIcon.Icon = New System.Drawing.Icon(Application.GetResourceStream(New Uri("Images\GrooveIconFull.ico", UriKind.Relative)).Stream)
                AddHandler notifyIcon.Click, AddressOf notifyIcon_Click
                notifyIcon.Visible = True

                If IO.File.Exists(IO.Path.Combine(Utilities.GetAppPath(), "customIcon.ico")) Then
                    'Dim icon As Image = New Image()
                    'icon.Source = New BitmapImage(New Uri(IO.Path.Combine(Utilities.myConfig.GetAppPath(), "customIcon.ico"), UriKind.Absolute))
                    'Me.Icon = icon.Source
                    log.logInfo("Downloader Window_Loaded", "Custom icon")
                    Me.Icon = New BitmapImage(New Uri(IO.Path.Combine(Utilities.GetAppPath(), "customIcon.ico"), UriKind.Absolute))
                    notifyIcon.Icon = New System.Drawing.Icon(IO.Path.Combine(Utilities.GetAppPath(), "customIcon.ico"))
                Else
                    Try
                        Me.Icon = BitmapFrame.Create(New Uri("pack://application:,,,/Images/GrooveIconFull.ico", UriKind.Absolute))
                    Catch
                        log.logWarning("Downloader Window_Loaded", "WinXP no 96 DPI Bug")
                    End Try
                End If

                Dim icon As Image = New Image()
                icon.Source = New BitmapImage(New Uri("Images\Heart.png", UriKind.Relative))
                icon.Width = 16
                icon.Height = 16

                mniDonate.Icon = icon
                SetConfigScreen()

                Me.Title = myProgram.longname & " - " & myProgram.version
                notifyIcon.BalloonTipTitle = Me.Title

                Call setGrooveClient()


                Dim tempThread As New Thread(AddressOf DoReconnect)
                tempThread.Start()

                Call ImportAllDownloadResults()
                SetResultTableColumnNames()
                SetDownloadTableColumnNames()

                If args.Length > 1 Then
                    Dim arguThread As New Thread(New ParameterizedThreadStart(AddressOf CheckArgumentsAsync))
                    arguThread.Start(args)
                End If
        Catch Ex As Exception
            log.logWarning("Downloader Window_Loaded Error", Ex.ToString())
            MsgBox(Ex.ToString(), MsgBoxStyle.Critical, "Error")
            Me.Close()
        End Try
    End Sub

    Private Sub CheckArgumentsAsync(args() As String)
        Try
            For I As Integer = 1 To args.Length - 1
                Dim argument As String = args(I)
                Select Case argument
                    Case "-download"
                        DoDownload()
                    Case "-search"
                        If (args.Length - 1) > I Then
                            I += 1
                            SetSearchBox(args(I))
                            BlockSearchButtons(Skin.getLanguageText("LangSearching", "Searching..."))
                            DoBaseSearch()
                        End If
                    Case "-popular"
                        BlockSearchButtons(Skin.getLanguageText("LangSearchingPopular", "Searching popular songs..."))
                        DoPopularSearch()
                    Case "-batch"
                        If (args.Length - 1) > I Then
                            I += 1
                            Dim filename As String = args(I)
                            BatchSearch(File.ReadAllText(filename))
                        End If
                    Case "-playlistById"
                        If (args.Length - 1) > I Then
                            I += 1
                            Dim playlistid As String = args(I)
                            getPlaylistById(playlistid, False)
                        End If
                    Case "-username"
                        If (args.Length - 1) > I Then
                            I += 1
                            Me.Dispatcher.Invoke(New SetControlPropertyDelegate(AddressOf SetControlProperty), New Object() {"txtLoginName", TextBox.TextProperty, args(I)})
                        End If
                    Case "-password"
                        If (args.Length - 1) > I Then
                            I += 1
                            Me.Dispatcher.Invoke(New SetControlPropertyDelegate(AddressOf SetControlProperty), New Object() {"txtLoginPass", Nothing, args(I)})
                        End If
                    Case "-loginAndFetchPlaylists"
                        If (args.Length - 1) > I Then
                            I += 1
                            'Fix it, write own method!
                            Me.Dispatcher.Invoke(New ControlDelegate(AddressOf btnLoginFetchPlaylists_Click), New Object() {vbNullString, vbNullString})

                            Try
                                If args(I) = "all" Then
                                    For Each playlist As UserGetPlaylists.MyResult In playlistResponse.result.Playlists
                                        getPlaylistById(playlist.playlistID, False)
                                    Next
                                ElseIf IsNumeric(args(I)) Then
                                    Dim num As Integer = args(I) - 1
                                    getPlaylistById(playlistResponse.result.Playlists(num).playlistID, False)
                                Else
                                    Dim PlaylistName As String = args(I)
                                    For Each playlist As UserGetPlaylists.MyResult In playlistResponse.result.Playlists
                                        If playlist.name = PlaylistName Then
                                            getPlaylistById(playlist.playlistID, False)
                                        End If
                                    Next
                                End If
                            Catch Ex As Exception
                                log.logWarning("Downloader Window_Loaded", "Invalid Number for commandline -add" & vbNewLine & Ex.ToString())
                            End Try
                        End If
                End Select

                Select Case argument
                    Case "-add"
                        If (args.Length - 1) > I Then
                            For J As Integer = 0 To FoundResults.Count - 1
                                FoundResults(J).Load = False
                                FoundResultsTable.Rows(J).Item("Load") = False
                            Next
                            I += 1
                            Try
                                If args(I) = "all" Then
                                    For J As Integer = 0 To FoundResults.Count
                                        FoundResults(J).Load = True
                                        FoundResultsTable.Rows(J).Item("Load") = True
                                    Next
                                Else
                                    Dim num As Integer = args(I) - 1
                                    FoundResults(num).Load = True
                                    FoundResultsTable.Rows(num).Item("Load") = True
                                End If
                            Catch Ex As Exception
                                log.logWarning("Downloader Window_Loaded", "Invalid Number for commandline -add" & vbNewLine & Ex.ToString())
                            End Try
                            Me.Dispatcher.Invoke(New ControlDelegate(AddressOf btnAddToDownloadList_Click), New Object() {vbNullString, vbNullString})
                        End If
                    Case "-clear"
                        Me.Dispatcher.Invoke(New ControlDelegate(AddressOf mniClearDownloadList_Click), New Object() {vbNullString, vbNullString})
                    Case "-show"
                        'Fehler
                        Me.WindowState = Windows.WindowState.Normal
                        Me.Dispatcher.Invoke(New EmptyDelegate(AddressOf Show))
                    Case "-exit"
                        Me.Dispatcher.Invoke(New EmptyDelegate(AddressOf Close))
                End Select
            Next
        Catch Ex As Exception
            AddDebug("CheckArgumentsAsync Error: " & " - " & Ex.ToString())
        End Try
    End Sub


    Private Delegate Sub SetControlPropertyDelegate(ByVal ControlName As String, ByVal ControlOption As DependencyProperty, ByVal Content As Object)
    Private Sub SetControlProperty(ByVal ControlName As String, ByVal ControlOption As DependencyProperty, ByVal Content As Object)
        Dim control As DependencyObject = LogicalTreeHelper.FindLogicalNode(DirectCast(WindowGrid.Children(0), DependencyObject), ControlName)
        If ControlOption IsNot Nothing Then
            control.SetValue(ControlOption, Content)
        Else 'Crappy Workaround for crappy missing PasswordBox.PasswordProperty...
            If TypeOf control Is PasswordBox Then
                DirectCast(control, PasswordBox).Password = Content
            End If
        End If


    End Sub


    Public Sub setGrooveClient(Optional ForceRecreate As Boolean = False)
        If grooveClient Is Nothing Or ForceRecreate Then
            If getProxy() Is Nothing Then
                grooveClient = New Groove.GroovesharkClient(True, Nothing)
            Else
                grooveClient = New Groove.GroovesharkClient(True, getProxy())
            End If
            grooveClient.DisallowMobileGrooveshark = UseTor
            grooveClient.UseGZip = True
            If isDebug Then
                grooveClient.EnableDebugLog()
                'AddHandler SciLorsGroovesharkAPI.Groove.Utilities.log.LogEvent, AddressOf toLog
            End If

            If TorProcess IsNot Nothing Then
                grooveClient.TimeOut = 20000
            End If
        End If
        If grooveBitRateClient Is Nothing Or ForceRecreate Then
            If getProxy() Is Nothing Then
                grooveBitRateClient = New Groove.GroovesharkClient(True)
            Else
                grooveBitRateClient = New Groove.GroovesharkClient(True, getProxy())
            End If
            grooveBitRateClient.UseGZip = True
            grooveBitRateClient.DisallowMobileGrooveshark = UseTor
        End If
    End Sub

    Private Function getProxy() As IWebProxy
        Try
            Dim proxyString As String = myConfig.Settings.Proxy.Trim()
            If TempProxy IsNot Nothing Then
                If Not TempProxy.Trim() = "" Then
                    proxyString = TempProxy.Trim()
                End If
            End If
            If proxyString = "" Then Return Nothing

            Dim proxy As New System.Net.WebProxy(proxyString)

            If myConfig.Settings.ProxyUser.Length > 0 And myConfig.Settings.ProxyPass.Length > 0 Then
                proxy.Credentials = New NetworkCredential(myConfig.Settings.ProxyUser, myConfig.Settings.ProxyPass)
            End If

            Return proxy
        Catch ex As Exception
            AddDebug("Proxy Error: " & ex.GetType.ToString & " - " & ex.Message)
            Return Nothing
        End Try
    End Function

    Private Sub SetConfigScreen()
        log.logInfo("Downloader SetConfigScreen", "Begin")
        Call myConfig.Load()
        With myConfig.Settings
            txtBaseDir.Text = .DownloadDir
            cmbPattern.Text = .NamePattern
            chkUncheckSearchResults.IsChecked = .UncheckAfterAdd
            chkAutoCheckUpdates.IsChecked = .AutoCheckUpdates
            Select Case .ExistingFileHandling
                Case Settings.ExistingFileHandling.Overwrite
                    rbtExistingOverwrite.IsChecked = True
                Case Settings.ExistingFileHandling.Rename
                    rbtExistingAutoRename.IsChecked = True
                Case Else
                    rbtExistingSkip.IsChecked = True
            End Select
            txtProxy.Text = .Proxy
        End With
        Call cmbPattern_TextChanged(New Object, New System.EventArgs)
    End Sub


    Private Sub BlockSearchButtons(ByVal DebugText As String)
        If Me.Dispatcher.Thread Is Thread.CurrentThread Then
            Mouse.OverrideCursor = Cursors.AppStarting
            txtSearch.IsEnabled = False
            btnSearch.IsEnabled = False
            btnPopularSongs.IsEnabled = False
            btnBatchSearch.IsEnabled = False

            'btnSearch.Content = "Searching..."
            AddDebug(DebugText)
        Else
            Me.Dispatcher.Invoke(New TextDelegate(AddressOf BlockSearchButtons), DebugText)
        End If
    End Sub

    Private Sub ReleaseSearchButtons()
        If Me.Dispatcher.Thread Is Thread.CurrentThread Then
            txtSearch.IsEnabled = True
            btnSearch.IsEnabled = True
            btnPopularSongs.IsEnabled = True
            btnBatchSearch.IsEnabled = True

            'btnSearch.Content = "Search"
            Mouse.OverrideCursor = Nothing
        Else
            Me.Dispatcher.Invoke(New EmptyDelegate(AddressOf ReleaseSearchButtons))
        End If
    End Sub

    Private Sub ClearSearchTable()
        dagSearch.ItemsSource = Nothing

        FoundResults.Clear()
        FoundResultsTable.Clear()
        FoundResultsTable.Dispose()
        FoundResults = New List(Of EnhancedResultGrid)
        FoundResultsTable = EnhancedResultGrid.ReturnEnhancedTable

        FoundResults.Clear()
        FoundResultsTable.Clear()
        dagSearch.Items.Clear()

        txtResultFilter.Text = ""

        SetResultTableColumnNames()
    End Sub

    Private Delegate Sub DoSearchDelegate(ByVal Data As List(Of Groove.Functions.SearchArtist.SearchArtistResult), ByVal Clear As Boolean)
    Private Sub DoSearch(ByVal Data As List(Of Groove.Functions.SearchArtist.SearchArtistResult), Optional ByVal Clear As Boolean = True)
        'SetSongBitrates(Data)
        DoRealSearch(Data, Clear)
    End Sub
    Private Sub DoRealSearch(ByVal Data As List(Of Groove.Functions.SearchArtist.SearchArtistResult), ByVal Clear As Boolean)
        If Me.Dispatcher.Thread Is Thread.CurrentThread Then
            log.logInfo("Downloader DoSearch", "Begin")
            Try
                If Clear Then Call ClearSearchTable()

                For Each SearchItem As Groove.Functions.SearchArtist.SearchArtistResult In Data
                    FoundResults.Add(New EnhancedResultGrid(SearchItem))
                    FoundResultsTable.Rows.Add(EnhancedResultGrid.CreateEnhancedTableRow(FoundResultsTable, FoundResults.Last))
                Next

                FoundResultsTable.AcceptChanges()
                Dim view As DataView = FoundResultsTable.AsDataView
                'view.RowFilter = "Artist LIKE 'K*'"

                dagSearch.ItemsSource = view
                SetResultTableColumnNames()

                AddDebug(Skin.getLanguageText("LangFoundResults", "Found * results").Replace("*", FoundResults.Count))
            Catch ex As Exception
                If Clear Then Call ClearSearchTable()

                AddDebug("Error: " & ex.GetType.ToString & " - " & ex.Message)
            Finally
                Call ReleaseSearchButtons()
            End Try
        Else
            Me.Dispatcher.Invoke(New DoSearchDelegate(AddressOf DoSearch), New Object() {Data, Clear})
        End If

    End Sub

    Private Delegate Sub EmptyDelegate()
    Private Sub DoBaseSearch()
        Try
            Call DoSearch(grooveClient.SearchArtist(CurrentSearch).result.result)
        Catch ex As Exception
            AddDebug("Error: " & ex.GetType.ToString & " - " & ex.Message)
            Call ReleaseSearchButtons()
        End Try
    End Sub

    Private Sub DoPopularSearch()
        Try
            Call DoSearch(grooveClient.PopularSongs().result.Songs)
        Catch ex As Exception
            AddDebug("Error: " & ex.GetType.ToString & " - " & ex.Message)
            Call ReleaseSearchButtons()
        End Try
    End Sub

    Private Sub DoSongOnGrooveshark(ByVal Song As SciLorsGroovesharkAPI.Groove.Functions.SearchArtist.SearchArtistResult)
        Try
            Process.Start(grooveClient.GetSongOnGrooveshark(Song.SongID))
        Catch ex As Exception
            AddDebug("Error: " & ex.GetType.ToString & " - " & ex.Message)
        End Try
        Call ReleaseSearchButtons()
    End Sub

    Private Sub DoSearchForAlbum(ByVal Song As SciLorsGroovesharkAPI.Groove.Functions.SearchArtist.SearchArtistResult)
        Try
            Call DoSearch(grooveClient.GetSongsByAlbum(Song).result.songs)
        Catch ex As Exception
            AddDebug("Error: " & ex.GetType.ToString & " - " & ex.Message)
            Call ReleaseSearchButtons()
        End Try
    End Sub

    Private Sub DoSearchForArtist(ByVal Song As SciLorsGroovesharkAPI.Groove.Functions.SearchArtist.SearchArtistResult)
        Try
            Call DoSearch(grooveClient.GetSongsByArtist(Song).result.songs)
        Catch ex As Exception
            AddDebug("Error: " & ex.GetType.ToString & " - " & ex.Message)
            Call ReleaseSearchButtons()
        End Try
    End Sub

    Private SearchThread As Thread
    Private Sub ClearThread(ByRef ResetThread As Thread)
        If ResetThread IsNot Nothing Then
            Try
                ResetThread.Abort()
            Catch ex As Exception
            End Try
            ResetThread = Nothing
        End If
    End Sub

    Private Sub SetDownloadTableColumnNames()
        If dagDownload.Columns.Count > 0 Then
            Dim ColumCount As Integer = 0
            dagDownload.Columns(ColumCount).Header = Skin.getLanguageText("LangTableArtist", "Artist")
            ColumCount += 1
            dagDownload.Columns(ColumCount).Header = Skin.getLanguageText("LangTableTitle", "Title")
            ColumCount += 1
            dagDownload.Columns(ColumCount).Header = Skin.getLanguageText("LangTableAlbum", "Album")
            ColumCount += 1
            dagDownload.Columns(ColumCount).Header = Skin.getLanguageText("LangTableYear", "Year")
            ColumCount += 1
            dagDownload.Columns(ColumCount).Header = Skin.getLanguageText("LangTableLength", "Length")
            ColumCount += 1
            dagDownload.Columns(ColumCount).Header = Skin.getLanguageText("LangTableBitrate", "Bitrate")
        Else

        End If
    End Sub

    Private Sub SetResultTableColumnNames()
        If dagSearch.Columns.Count > 0 Then
            Dim ColumCount As Integer = 0
            dagSearch.Columns(ColumCount).Header = Skin.getLanguageText("LangTableLoad", "Load")
            ColumCount += 1
            dagSearch.Columns(ColumCount).Header = Skin.getLanguageText("LangTableArtist", "Artist")
            ColumCount += 1
            dagSearch.Columns(ColumCount).Header = Skin.getLanguageText("LangTableTitle", "Title")
            ColumCount += 1
            dagSearch.Columns(ColumCount).Header = Skin.getLanguageText("LangTableAlbum", "Album")
            ColumCount += 1
            dagSearch.Columns(ColumCount).Header = Skin.getLanguageText("LangTableYear", "Year")
            ColumCount += 1
            dagSearch.Columns(ColumCount).Header = Skin.getLanguageText("LangTableLength", "Length")
            ColumCount += 1
            dagSearch.Columns(ColumCount).Header = Skin.getLanguageText("LangTableBitrate", "Bitrate")
        End If
    End Sub

    Private Sub btnSearch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Call ClearThread(SearchThread)
        BlockSearchButtons(Skin.getLanguageText("LangSearching", "Searching..."))
        SearchThread = New Thread(AddressOf DoBaseSearch)
        SearchThread.Start()
    End Sub

    Private Sub btnPopularSongs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Call ClearThread(SearchThread)
        BlockSearchButtons(Skin.getLanguageText("LangSearchingPopular", "Searching popular songs..."))
        SearchThread = New Thread(AddressOf DoPopularSearch)
        SearchThread.Start()
    End Sub

    Private Sub mniClearDownloadList_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        If Not DownloadEnabled Then
            dagDownload.ItemsSource = Nothing

            DownloadResultsTable.Rows.Clear()
            DownloadResults.Clear()

            DownloadResults = Nothing
            DownloadResultsTable = Nothing

            DownloadResults = New List(Of ResultGrid)()
            DownloadResultsTable = ResultGrid.ReturnBaseTable

            dagDownload.ItemsSource = DownloadResultsTable.AsDataView
            SetDownloadTableColumnNames()

            Call ExportAllDownloadResults()
        End If
    End Sub

    Private Sub btnAddToDownloadList_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Try
            For I = 0 To FoundResults.Count - 1
                Dim AddResult As ResultGrid = New ResultGrid(FoundResults(I).Result)
                If FoundResultsTable.Rows(I).Field(Of Boolean)("Load") And Not DownloadResults.Contains(AddResult) Then
                    DownloadResults.Add(AddResult)
                    DownloadResultsTable.Rows.Add(ResultGrid.CreateBaseTableRow(DownloadResultsTable, DownloadResults.Last))
                End If
                If myConfig.Settings.UncheckAfterAdd Then FoundResultsTable.Rows(I).Item("Load") = False
            Next
        Catch
        End Try
        dagDownload.ItemsSource = DownloadResultsTable.AsDataView
        SetDownloadTableColumnNames()

        Call ExportAllDownloadResults()
    End Sub

    Private Sub ExportAllDownloadResults(Optional CheckForAdmin As Boolean = True)
        Try
            Dim FileWrite As New StreamWriter(DownloadResultsPath)
            Dim xmlSerializer As New XmlSerializer(DownloadResults.GetType, New Type() {GetType(ResultGrid)})

            xmlSerializer.Serialize(FileWrite, DownloadResults)
            FileWrite.Close()
        Catch ex As UnauthorizedAccessException
            If CheckForAdmin Then AdministrationRightsNeeded()
        End Try
    End Sub

    Private Sub ImportAllDownloadResults()
        If File.Exists(DownloadResultsPath) Then
            Try
                dagDownload.ItemsSource = Nothing
                DownloadResultsTable.Rows.Clear()
                DownloadResults.Clear()

                Dim FileRead As New StreamReader(DownloadResultsPath)
                Dim xmlSerializer As New XmlSerializer(DownloadResults.GetType, New Type() {GetType(ResultGrid)})

                DownloadResults = xmlSerializer.Deserialize(FileRead)
                FileRead.Close()

                DownloadResultsTable = ResultGrid.ReturnBaseTable()
                For I = 0 To DownloadResults.Count - 1
                    DownloadResultsTable.Rows.Add(ResultGrid.CreateBaseTableRow(DownloadResultsTable, DownloadResults(I)))
                Next

                dagDownload.ItemsSource = DownloadResultsTable.AsDataView
                'dagDownload.Items

                SetDownloadTableColumnNames()
            Catch ex As Exception
                AddDebug(Skin.getLanguageText("LangBrokenDownloadList", "Error: Download list corrupted, loading empty list...") + " - " + ex.Message)
                dagDownload.ItemsSource = Nothing
                DownloadResultsTable.Rows.Clear()
                DownloadResults.Clear()
                Try
                    File.Delete(DownloadResultsPath)
                Catch
                End Try
            End Try
        End If
    End Sub

    Private Delegate Sub IntegerDelegate(ByVal Value As Integer)
    Private Sub SetDownloadProgress(ByVal Value As Integer)
        If Me.Dispatcher.Thread Is Thread.CurrentThread Then
            pgbDownloadState.Value = Value
            Dim tempString As String = Int((Value / pgbDownloadState.Maximum) * 100) & "%"
        Else
            Me.Dispatcher.Invoke(New IntegerDelegate(AddressOf SetDownloadProgress), Value)
        End If

        'Using tempGraphics As Graphics = pgbDownloadState.CreateGraphics
        '    Dim tempSize As SizeF = tempGraphics.MeasureString(tempString, Me.Font)
        '    tempGraphics.DrawString(tempString, Me.Font, Brushes.Black, pgbDownloadState.ClientSize.Width / 2 - tempSize.Width / 2, pgbDownloadState.ClientSize.Height / 2 - tempSize.Height / 2)
        'End Using
    End Sub
    Private Sub SetDownloadStateMax(ByVal Value As Integer)
        If Me.Dispatcher.Thread Is Thread.CurrentThread Then
            pgbDownloadState.Maximum = Value
        Else
            Me.Dispatcher.Invoke(New IntegerDelegate(AddressOf SetDownloadStateMax), Value)
        End If
    End Sub
    Private Sub SetDownloadSelected(ByVal Value As Integer)
        If Me.Dispatcher.Thread Is Thread.CurrentThread Then
            dagDownload.SelectedIndex = Value
        Else
            Me.Dispatcher.Invoke(New IntegerDelegate(AddressOf SetDownloadSelected), Value)
        End If
    End Sub
    Private Sub RemoveDownloaded(ByVal ErrorCount As Integer)
        If Me.Dispatcher.Thread Is Thread.CurrentThread Then
            DownloadResults.RemoveAt(ErrorCount)
            DownloadResultsTable.Rows.RemoveAt(ErrorCount)

            DownloadResultsTable.AcceptChanges()
            dagDownload.Items.Refresh()
        Else
            Me.Dispatcher.Invoke(New IntegerDelegate(AddressOf RemoveDownloaded), ErrorCount)
        End If
    End Sub

    Private Sub StartDownload()
        If Me.Dispatcher.Thread Is Thread.CurrentThread Then
            Mouse.OverrideCursor = Cursors.AppStarting
            btnDownload.Content = Skin.getLanguageText("LangStopDownload", "Stop Downloading")
        Else
            Me.Dispatcher.Invoke(New EmptyDelegate(AddressOf StartDownload))
        End If
    End Sub

    Private Sub EndDownload()
        If Me.Dispatcher.Thread Is Thread.CurrentThread Then
            btnDownload.IsEnabled = False
            btnDownload.Content = Skin.getLanguageText("btnDownload", "Download")
            DownloadEnabled = False
            Mouse.OverrideCursor = Nothing
            btnDownload.IsEnabled = True
        Else
            Me.Dispatcher.Invoke(New EmptyDelegate(AddressOf EndDownload))
        End If
    End Sub

    Private Sub DoDownload()
        If Not DownloadEnabled Then
            DownloadEnabled = True
            Call StartDownload()

            Dim ErrorCount As Integer = 0
            DownloadItemID = ErrorCount
            Dim tempFile As FileStream = Nothing
            Dim tempFileName As String = ""
            Do Until dagDownload.Items.Count = ErrorCount Or DownloadEnabled = False
                AddDebug(Skin.getLanguageText("LangStartDownload", "Start downloading") & " " & SongRenamePattern(myConfig.Settings.NamePattern, DownloadResults(ErrorCount).Result))

                Dim AppendNum As String = ""
                Try
                    Dim CurrentCount As Integer = 0
                    Do
                        tempFileName = IO.Path.Combine(myConfig.Settings.DownloadDir, SongRenamePattern(myConfig.Settings.NamePattern, DownloadResults(ErrorCount).Result, AppendNum))
                        CurrentCount += 1
                        AppendNum = "(" & CurrentCount & ")"
                    Loop While File.Exists(tempFileName) And myConfig.Settings.ExistingFileHandling = Settings.ExistingFileHandling.Rename


                    Dim DataRead As Integer
                    Dim LoadedData As Integer = 0
                    Dim tempBuffer(1023) As Byte
                    Dim tmpExtension As String = ".tmp"

                    If tempFileName.Length + tmpExtension.Length >= 260 Then
                        Dim FileExists As Boolean = True
                        Try
                            IO.Win32File.OpenRead(tempFileName).Close()
                        Catch ex As Exception
                            FileExists = False
                        End Try

                        If FileExists And myConfig.Settings.ExistingFileHandling = Settings.ExistingFileHandling.Skip Then
                            Throw New Exception(Skin.getLanguageText("LangFileSkipped", "File skipped"))
                        End If
                        log.logWarning("Downloading", "PathTooLong Length >=260")
                        If IO.Directory.Exists(IO.Win32Path.GetDirectoryName(tempFileName)) = False Then
                            IO.Directory.CreateDirectory(IO.Win32Path.GetDirectoryName(tempFileName))
                        End If
                        tempFile = IO.Win32File.Open(tempFileName + tmpExtension, IO.FileMode.Create)
                    Else
                        If File.Exists(tempFileName) And myConfig.Settings.ExistingFileHandling = Settings.ExistingFileHandling.Skip Then
                            Throw New Exception(Skin.getLanguageText("LangFileSkipped", "File skipped"))
                        End If
                        If IO.Directory.Exists(IO.Path.GetDirectoryName(tempFileName)) = False Then
                            IO.Directory.CreateDirectory(IO.Path.GetDirectoryName(tempFileName))
                        End If
                        tempFile = IO.File.Open(tempFileName + tmpExtension, IO.FileMode.Create)
                    End If

                    'grooveClient = New SciLorsGroovesharkAPI.Groove.GroovesharkClient(False)

                    Dim tempMusic As Groove.Music.GroovesharkAudioStream = grooveClient.GetMusicStream(DownloadResults(ErrorCount).Result.SongID, DownloadResults(ErrorCount).Result.ArtistID)
                    SetDownloadProgress(0)
                    SetDownloadStateMax(tempMusic.Length)
                    SetDownloadSelected(ErrorCount)

                    Dim MarkedAsPlayed As Boolean = False
                    Dim MarkedAsDownloaded As Boolean = False
                    Do Until tempMusic.Length = LoadedData
                        DataRead = tempMusic.Stream.Read(tempBuffer, 0, tempBuffer.Length)
                        tempFile.Write(tempBuffer, 0, DataRead)
                        LoadedData += DataRead
                        SetDownloadProgress(LoadedData)
                        'Application.DoEvents()
                        'DoEvents(Me.Dispatcher)
                        If Not MarkedAsPlayed And LoadedData > 1024 * 10 Then
                            MarkedAsPlayed = True
                            'tempMusic.MarkSongPlayed()
                        End If
                        If Not MarkedAsDownloaded And LoadedData > 1024 Then
                            MarkedAsDownloaded = True
                            tempMusic.MarkAsDownloaded()
                        End If
                        If DownloadEnabled = False Then
                            'tempMusic.RemoveSongFromQueue()
                            tempMusic.Stream.Close()
                            tempFile.Close()
                            Throw New Exception(Skin.getLanguageText("LangDownloadAbort", "Download aborted"))
                        End If
                    Loop

                    SetDownloadProgress(LoadedData)
                    'Application.DoEvents()
                    'DoEvents(Me.Dispatcher)

                    tempMusic.Stream.Close()
                    tempFile.Close()

                    File.Move(tempFileName + tmpExtension, tempFileName)

                    'tempMusic.RemoveSongFromQueue()

                    RemoveDownloaded(ErrorCount)
                    ExportAllDownloadResults()

                    Call PostDownloadEvent(tempFileName)
                Catch ex As Exception
                    Try
                        If tempFile IsNot Nothing Then tempFile.Close()
                    Catch e As Exception
                    End Try
                    If ex.Message = Skin.getLanguageText("LangDownloadAbort", "Download aborted") Then

                        AddDebug(Skin.getLanguageText("LangManualAbort", "Manual abort:") & " " & ex.GetType.ToString & " - " & ex.Message & " - " & """" & tempFileName & """" & " deleted!")
                    ElseIf ex.Message = Skin.getLanguageText("LangFileSkipped", "File skipped") Then
                        AddDebug(Skin.getLanguageText("LangFileSkipped", "File skipped") & " " & tempFileName)
                    Else
                        AddDebug("Error: " & ex.GetType.ToString & " - " & ex.Message & " - " & """" & tempFileName & """" & " deleted!")
                    End If
                    Try
                        If Not ex.Message = Skin.getLanguageText("LangFileSkipped", "File skipped") Then IO.File.Delete(tempFileName)
                    Catch
                    End Try
                    ErrorCount += 1
                    DownloadItemID = ErrorCount
                End Try
            Loop

            Call PostAllDownloadEvent()

            Call EndDownload()
            SetDownloadProgress(0)
        Else
            Call EndDownload()
        End If
    End Sub

    Private Sub PostDownloadEvent(ByVal Path As String)
        AddDebug(Skin.getLanguageText("LangPostDownloadEvent", "Executing Post Download Event"))
    End Sub

    Private Sub PostAllDownloadEvent()
        AddDebug(Skin.getLanguageText("LangPostAllDownloadEvent", "Executing All Download Event"))
    End Sub

    Private DownloadThread As Thread

    Private Sub btnDownload_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        If (DownloadThread IsNot Nothing) Then
            If DownloadEnabled = True Then
                DownloadEnabled = False
                While (Not DownloadThread.ThreadState = ThreadState.Stopped)
                    DoEvents(Me.Dispatcher)
                End While
                DownloadEnabled = True
            End If
        End If
        ClearThread(DownloadThread)
        DownloadThread = New Thread(AddressOf DoDownload)
        DownloadThread.Start()
    End Sub

    Private Sub mniExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Me.Close()
        Application.Current.Shutdown()
    End Sub

    Private Sub mniCheckForUpdates_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        MyStartUp.UpdateCheck(True)
    End Sub

    Private Sub mniAvailableSoftware_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Dim UpdateChecker As New SciLors_UpdateCheck.SciLorsUpdateCheck()
        MsgBox(UpdateChecker.getAll, MsgBoxStyle.OkOnly, "SciLor's Software")
    End Sub

    Private Sub mniSciLorsWebsite_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Dim ShellEx As New ProcessStartInfo()
        ShellEx.UseShellExecute = True
        ShellEx.FileName = "http://www.scilor.com"
        Process.Start(ShellEx)
    End Sub

    Private Sub txtSearch_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Input.KeyEventArgs)
        If e.Key = Key.Return Then
            Call btnSearch_Click(sender, New EventArgs())
        End If
    End Sub

    Private LastArtistAutocomplete As String
    Private IsArtistAutocompleteChange As Boolean = False
    Private Sub txtSearch_TextChanged(ByVal sender As Object, ByVal e As System.Windows.Controls.TextChangedEventArgs)
        CurrentSearch = txtSearch.Text
        If grooveClient Is Nothing Then Return
        If grooveClient.IsMobileShark Then Return

        If autocompleteEnabled Then
            If Not IsArtistAutocompleteChange Then
                If e.Changes.Count = 0 Or e.Changes(0).AddedLength > 0 Then
                    LastArtistAutocomplete = CurrentSearch
                    IsArtistAutocompleteChange = False
                    Dim thread As New Thread(New ParameterizedThreadStart(AddressOf ArtistAutocomplete))
                    thread.Start(CurrentSearch)
                End If
            Else
                IsArtistAutocompleteChange = False
            End If
        End If
    End Sub

    Private Sub ArtistAutocomplete(ByVal Search As String)
        Try
            Dim results As List(Of ArtistAutocomplete.ArtistList) = grooveClient.GetArtistAutoComplete(Search)
            If results.Count > 0 Then
                If LastArtistAutocomplete = Search Then
                    SetArtistAutocomplete(results(0).Name)
                End If
            End If
        Catch ex As Exception
            AddDebug("Error: " & ex.Message)
        End Try
    End Sub
    Private Sub SetArtistAutocomplete(ByVal Result As String)
        If Me.Dispatcher.Thread Is Thread.CurrentThread Then
            If Result.ToLowerInvariant().StartsWith(CurrentSearch.ToLowerInvariant()) Then
                Dim Len As Integer = txtSearch.Text.Length
                IsArtistAutocompleteChange = True
                txtSearch.Text &= Result.Substring(Len)
                txtSearch.Select(Len, Result.Length - Len)
            End If
        Else
            Me.Dispatcher.Invoke(New TextDelegate(AddressOf SetArtistAutocomplete), Result)
        End If
    End Sub

    Private Sub cmbPattern_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim mySongTest As New SciLorsGroovesharkAPI.Groove.Functions.SearchArtist.SearchArtistResult()
        With mySongTest
            .ArtistName = "The Singers"
            .SongName = "My Song"
            .AlbumName = "Old Album Remix"
            .Year = "2010"
            .TrackNum = "7"
        End With

        lblPatternPreview.Content = Skin.getLanguageText("LangLblPatternPreview", "Preview:") & " " & SongRenamePattern(cmbPattern.Text, mySongTest)
    End Sub

    Private Sub btnBaseDir_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Dim DirectorySelector As New Forms.FolderBrowserDialog()
        DirectorySelector.RootFolder = Environment.SpecialFolder.DesktopDirectory
        DirectorySelector.SelectedPath = txtBaseDir.Text
        If DirectorySelector.ShowDialog = System.Windows.Forms.DialogResult.OK Then
            txtBaseDir.Text = DirectorySelector.SelectedPath
        End If
    End Sub

    Private Sub btnSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        With myConfig.Settings
            .DownloadDir = txtBaseDir.Text
            If Not StripIllegalFileName(cmbPattern.Text) = "" Then
                .NamePattern = cmbPattern.Text
            Else
                MsgBox(Skin.getLanguageText("LangInvalidNamingPattern", "Song naming pattern cannot be empty or only consist of invalid filename characters!"), MsgBoxStyle.Critical, "Error")
            End If
            .UncheckAfterAdd = chkUncheckSearchResults.IsChecked
            .AutoCheckUpdates = chkAutoCheckUpdates.IsChecked

            If Not .Proxy = txtProxy.Text Or Not .ProxyUser = txtProxyUser.Text Or Not .ProxyPass = txtProxyPass.Password Then
                .Proxy = txtProxy.Text
                .ProxyUser = txtProxyUser.Text
                .ProxyPass = txtProxyPass.Password
                Call setGrooveClient(True)
                Call mniReconnect_Click(Nothing, Nothing)
            End If


            If rbtExistingAutoRename.IsChecked Then
                .ExistingFileHandling = Utilities.Settings.ExistingFileHandling.Rename
            ElseIf rbtExistingOverwrite.IsChecked Then
                .ExistingFileHandling = Utilities.Settings.ExistingFileHandling.Overwrite
            Else
                .ExistingFileHandling = Utilities.Settings.ExistingFileHandling.Skip
            End If

        End With
        Call myConfig.Save()
    End Sub

    Private Sub SetSearchBox(ByVal Text As String)
        If Me.Dispatcher.Thread Is Thread.CurrentThread Then
            autocompleteEnabled = False
            txtSearch.Text = Text
            autocompleteEnabled = True
        Else
            Me.Dispatcher.Invoke(New TextDelegate(AddressOf SetSearchBox), Text)
        End If

    End Sub

    Private Sub BatchAddToDownload()
        FoundResults(0).Load = True
        FoundResultsTable.Rows(0).Item("Load") = True
        Call btnAddToDownloadList_Click(New Object(), New EventArgs())
    End Sub

    Private Sub BatchSearch(ByVal SearchString As String)
        Dim tempData() As String = Split(SearchString, vbNewLine)
        For i = 0 To tempData.Length - 1
            If Not tempData(i).Trim = "" Then
                Me.Dispatcher.Invoke(New TextDelegate(AddressOf BlockSearchButtons), Skin.getLanguageText("LangBatchSearching", "Batch searching...") & " " + tempData(i) + "(" + (i + 1).ToString() + "/" + tempData.Length.ToString() + ")")
                Me.Dispatcher.Invoke(New TextDelegate(AddressOf SetSearchBox), tempData(i))
                Call DoBaseSearch()

                If FoundResults.Count > 0 Then
                    Me.Dispatcher.Invoke(New EmptyDelegate(AddressOf BatchAddToDownload))
                End If
            End If
        Next
    End Sub

    Private Delegate Sub ControlDelegate(ByVal sender As System.Object, ByVal e As System.EventArgs)
    Private Sub btnBatchSearch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Call ClearThread(SearchThread)

        SearchThread = New Thread(AddressOf BatchSearch)
        SearchThread.Start(txtBatchSearch.Text.Trim())
    End Sub

    Private userID As Integer = -1
    Private playlistResponse As SciLorsGroovesharkAPI.Groove.Functions.UserGetPlaylists.userGetPlaylistsResponse
    Private Sub btnLoginFetchPlaylists_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Mouse.OverrideCursor = Cursors.AppStarting
        grpPlaylists.IsEnabled = False
        Try
            Dim loginResponse As AuthenticateUserEx.authenticateUserExResponse = grooveClient.Login(txtLoginName.Text, txtLoginPass.Password)
            If loginResponse.result.authRealm = "1" Then
                userID = loginResponse.result.userID

                playlistResponse = grooveClient.GetPlaylists(userID)
                cmbFetchPlaylists.Items.Clear()

                For Each element As UserGetPlaylists.MyResult In playlistResponse.result.Playlists
                    cmbFetchPlaylists.Items.Add(element.name & " (" & element.about & ")")
                Next
                If cmbFetchPlaylists.Items.Count > 0 Then
                    cmbFetchPlaylists.SelectedIndex = 0
                End If
                grpPlaylists.IsEnabled = True
            Else
                MsgBox(Skin.getLanguageText("LangLoginUnsuccessful", "Login unsuccessful, please try again!"), MsgBoxStyle.Critical, "Error")
            End If
        Catch ex As Exception
            AddDebug("Error: " & ex.GetType.ToString & " - " & ex.Message & " - " & "Login/Playlist fetching error")
        End Try
        Mouse.OverrideCursor = Nothing
    End Sub
    Private Sub txtLoginPass_KeyUp(sender As Object, e As KeyEventArgs)
        If e.Key = Key.Return Then
            btnLoginFetchPlaylists_Click(Nothing, Nothing)
        End If
    End Sub

    Private Sub btnFetchPlaylists_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        If cmbFetchPlaylists.SelectedIndex >= 0 Then
            getPlaylistById(playlistResponse.result.Playlists(cmbFetchPlaylists.SelectedIndex).playlistID)
            tabMain.SelectedIndex = 0
        End If
    End Sub

    Private Sub btnFetchPlaylistsById_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        getPlaylistById(txtPlaylistId.Text)
    End Sub

    Private Sub getPlaylistById(ByVal PlaylistId As String, Optional ByVal Clear As Boolean = True)
        Try
            BlockSearchButtons(Skin.getLanguageText("LangFetchingPlaylist", "Fetching Playlist") & " (" & PlaylistId & ")...")
            Call DoSearch(grooveClient.GetPlaylistSongs(PlaylistId).result.Songs, Clear)
        Catch ex As Exception
            AddDebug("Error: " & ex.GetType.ToString & " - " & ex.Message & " - " & "Playlist Song fetching error")
        End Try
    End Sub

    Dim CurrentDebugText As String = "Debug Log"

    Public Sub AddDebug(ByVal DebugText As String)
        If Me.Dispatcher.Thread Is Thread.CurrentThread Then
            log.logDebug("Downloader AddDebug", DebugText)

            CurrentDebugText &= vbNewLine & "[" & DateTime.Now.ToString() & "] " & DebugText
            If CurrentDebugText.Length > 65535 Then
                CurrentDebugText = CurrentDebugText.Substring(CurrentDebugText.Length - txtDebug.Text.Length)
            End If
            If txtDebug IsNot Nothing Then
                'txtDebug.SuspendLayout()
                txtDebug.Text = CurrentDebugText
                txtDebug.SelectionStart = txtDebug.Text.Length
                txtDebug.ScrollToEnd()
                'txtDebug.ResumeLayout()
            End If
        Else
            Me.Dispatcher.Invoke(New TextDelegate(AddressOf AddDebug), DebugText)
        End If
    End Sub

    Private Sub mniSettings_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        'Call myConfig.Load()
        'frmConfig.txtDownloadDir.Text = myConfig.Settings.DownloadDir
        'frmConfig.cmbNamePattern.Text = myConfig.Settings.NamePattern
        'frmConfig.chbUncheckAfterAdd.Checked = myConfig.Settings.UncheckAfterAdd
        'frmConfig.chbAutoUpdate.Checked = myConfig.Settings.AutoCheckUpdates
        'Call frmConfig.Show()
    End Sub

    Private Sub dagDownload_MouseLeftButtonUp(ByVal sender As System.Object, ByVal e As System.Windows.Input.MouseButtonEventArgs)
        If dagDownload.SelectedIndex > -1 And (Not DownloadEnabled Or (DownloadEnabled And Not DownloadItemID = dagDownload.SelectedIndex)) Then
            If MsgBox(Skin.getLanguageText("LangRemoveEntry", "Remove entry") & " " & (dagDownload.SelectedIndex + 1) & "?", MsgBoxStyle.YesNo, "Are you sure?") = MsgBoxResult.Yes Then
                'AddDebug(dagDownload.SelectedIndex)
                DownloadResults.RemoveAt(dagDownload.SelectedIndex)
                DownloadResultsTable.Rows.RemoveAt(dagDownload.SelectedIndex)
            End If
        End If
    End Sub

    Private Sub mniDonate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Process.Start("http://www.scilor.com/donate.html")
    End Sub

    Private Sub mniMazda_Click(sender As Object, e As RoutedEventArgs)
        Process.Start("http://forum.scilor.com/viewtopic.php?f=3&t=1753&p=4087#p4087")
    End Sub

    Private Sub mniFacebook_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        Process.Start("http://www.facebook.com/pages/SciLors-Groovesharktm-Downloader/166460443397491")
    End Sub

    Private Sub mniGroovesharkGermany_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        Process.Start("http://www.scilor.com/grooveshark-unlocker.html")
    End Sub


    Private VidaliaProcess As Process
    Private TorProcess As Process
    Private PolipoProcess As Process
    Private Sub RunTor()
        Try
            Dim p As New ProcessStartInfo()
            p.FileName = GetAppPath() & "\Tor\tor.exe"
            p.WorkingDirectory = GetAppPath() & "\Tor"
            p.WindowStyle = ProcessWindowStyle.Hidden
            p.RedirectStandardOutput = True
            p.RedirectStandardError = True
            p.UseShellExecute = False
            p.CreateNoWindow = True
            p.Arguments = "-f torrc DataDirectory tor"
            TorProcess = Process.Start(p)

            'p = New ProcessStartInfo()
            'p.FileName = GetAppPath() & "\Tor\vidalia.exe"
            'p.WorkingDirectory = GetAppPath() & "\Tor"
            ''p.WindowStyle = ProcessWindowStyle.Hidden
            'VidaliaProcess = Process.Start(p)


            p = New ProcessStartInfo()
            p.FileName = GetAppPath() & "\Tor\polipo.exe"
            p.WorkingDirectory = GetAppPath() & "\Tor"
            p.WindowStyle = ProcessWindowStyle.Hidden
            p.CreateNoWindow = True
            p.Arguments = "-c polipo"
            PolipoProcess = Process.Start(p)

            'Bootstrapped 100%: Done.
            'Established listening socket on port 8118.


            Dim tor As Boolean
            While Not tor
                Dim torText As String = ""
                Dim polipoText As String = ""

                If TorProcess.StandardOutput.BaseStream.CanRead Then
                    torText = TorProcess.StandardOutput.ReadLine()
                End If

                If torText IsNot Nothing Then
                    If torText.Contains("Bootstrapped 100%: Done.") Then
                        tor = True
                    ElseIf torText.Contains("[error]") Then
                        AddDebug(Skin.getLanguageText("LangUseTorError", "Problem running Tor") & ": " & torText & " - " & TorProcess.StandardOutput.ReadToEnd())
                        TorProblem = True
                        tor = True
                    End If
                Else
                    AddDebug(Skin.getLanguageText("LangUseTorAnotherInstance", "Problem running Tor: " & " Is there another instance running? (check taskmanager ""tor.exe"")"))
                    If MessageBox.Show(
                        Skin.getLanguageText("LangUseTorAnotherInstanceMessageBox",
                            "There is already a tor instance" & vbNewLine & _
                            "Do you want to try to use it?"), "Tor Error", MessageBoxButton.YesNo, MessageBoxImage.Error, MessageBoxResult.Yes) = MessageBoxResult.No Then
                        TorProblem = True
                    End If
                    tor = True
                End If
            End While
            If TorProblem Then
                If MessageBox.Show(Skin.getLanguageText("LangUseTorKillOtherInstanceMessageBox",
                        "There seems to be a problem with Tor." & vbNewLine & _
                        "Do you want to try to force to exit all Tor instances?"), "Tor Error", MessageBoxButton.YesNo, MessageBoxImage.Error, MessageBoxResult.Yes) = MessageBoxResult.Yes Then
                    AddDebug(Skin.getLanguageText("LangUseTorKillOtherInstance", "Killing all tor and polipo processes"))
                    Dim ps() As Process = System.Diagnostics.Process.GetProcessesByName("tor")
                    For Each pc As Process In ps
                        Try
                            pc.Kill()
                        Catch ex As Exception
                        End Try
                    Next
                    ps = System.Diagnostics.Process.GetProcessesByName("polipo")
                    For Each pc As Process In ps
                        Try
                            pc.Kill()
                        Catch ex As Exception
                        End Try
                    Next
                    TorProblem = False
                Else
                    Return
                End If
            End If

            AddDebug(Skin.getLanguageText("LangUseTorSuccessful", "Tor successfully loaded."))

        Catch ex As Exception
            AddDebug(Skin.getLanguageText("LangUseTorError", "Problem with running Tor+Polipo. Maybe it is missing?") & " - " & ex.Message)
        End Try
    End Sub
    Private Sub StopTor()
        Try
            TorProcess.Kill()
        Catch ex As Exception
        End Try

        Try
            PolipoProcess.Kill()
        Catch ex As Exception
        End Try
    End Sub

    Private Sub DoReconnect()
        AddDebug(Skin.getLanguageText("LangStartReconnecting", "Start reconnecting..."))

        If UseTor And Not TorProblem Then
            AddDebug(Skin.getLanguageText("LangUseTor", "Trying to load Tor...") & " https://www.torproject.org/")
            StopTor()
            RunTor()
        End If

        Try
            If Not TorProblem Then
                setGrooveClient()

                Call grooveClient.Reconnect()

                If grooveClient.IsMobileShark Then
                    AddDebug(Skin.getLanguageText("LangUseMobile", "Using mobile grooveshark(tm), that may have limited functions (Maybe grooveshark(tm) is blocked in your country?)" & vbNewLine & vbNewLine & _
                                                  "If you need all functions, try to use a proxy or tor (SciLors GrooveDownloader WithTor.bat)"))
                End If

                AddDebug(Skin.getLanguageText("LangReconnected", "Reconnected!"))
            End If
        Catch ex As Exception
            If grooveClient.Gema And UseTor And Not TorProblem Then
                AddDebug(Skin.getLanguageText("LangUseTorCountry", "Loaded Tor, but had a german proxy, trying again..."))
                DoReconnect()
                Return
            End If
            AddDebug("Error: Reconnect unsuccessful - " & ex.Message)

            'If grooveClient.Gema And Not TorProblem Then
            '    If MessageBox.Show("Gema closed Grooveshark(tm) in Germany." & vbNewLine & _
            '                    "If you want to continue using this tool from Germany, you will need to use a proxy. " & vbNewLine & vbNewLine & _
            '                    "Do you want to try it through the Tor-Network?", "Gema block Grooveshark(tm) in Germany",
            '                    MessageBoxButton.YesNo, MessageBoxImage.Question, MessageBoxResult.Yes) = MessageBoxResult.Yes Then
            '        Process.Start(GetAppExe, "-tor -tempproxy 127.0.0.1:8118")
            '        Me.Dispatcher.Invoke(New EmptyDelegate(AddressOf Me.Close))
            '    End If
            'End If
        End Try
    End Sub
    Public Sub mniReconnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        TorProblem = False
        Dim tempThread As New Thread(AddressOf DoReconnect)
        tempThread.Start()
    End Sub

    'Private Sub DoStartupConnect()
    '    AddDebug(Skin.getLanguageText("LangStartReconnecting", "Start reconnecting..."))
    '    Try
    '        Call grooveClient.Reconnect()
    '        AddDebug(Skin.getLanguageText("LangReconnected", "Reconnected!"))
    '    Catch ex As Exception
    '        AddDebug("Error: Reconnect unsuccessful - " & ex.Message)
    '    End Try
    'End Sub

    Private Sub btnSelectAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        For i = 0 To FoundResults.Count - 1
            FoundResults(i).Load = True
            FoundResultsTable.Rows(i).Item("Load") = True
        Next
    End Sub

    Private Sub btnDeselectAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        For i = 0 To FoundResults.Count - 1
            FoundResults(i).Load = False
            FoundResultsTable.Rows(i).Item("Load") = False
        Next
    End Sub

    Private Sub btnInvertSelection_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        For i = 0 To FoundResults.Count - 1
            FoundResultsTable.Rows(i).Item("Load") = Not FoundResultsTable.Rows(i).Item("Load")
            FoundResults(i).Load = FoundResultsTable.Rows(i).Item("Load")
        Next
    End Sub

    Private Sub mniBatchSearchAndAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        'frmBatchSearchAndAdd.Show()
    End Sub

    Private Sub mniLoadPlaylists_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        'frmLoadPlaylists.Show()
    End Sub

    Private Sub dagSearch_SelectionChanged(ByVal sender As Object, ByVal e As SelectionChangedEventArgs)
        'For Each element As DataRowView In dagSearch.SelectedItems
        '    Dim i As Integer = FoundResultsTable.Rows.IndexOf(element.Row)
        '    FoundResults(i).Load = True
        '    FoundResultsTable.Rows(i).Item("Load") = True
        'Next
    End Sub

    Private Sub dagSearch_Click(ByVal sender As Object, ByVal e As MouseButtonEventArgs)
        If e.ChangedButton = MouseButton.Right Or e.ChangedButton = MouseButton.Left Then
            Dim depObj As DependencyObject = e.OriginalSource

            While depObj IsNot Nothing And Not TypeOf depObj Is DataGridCell And Not TypeOf depObj Is GridViewColumnHeader
                depObj = VisualTreeHelper.GetParent(depObj)
            End While

            If depObj IsNot Nothing Then
                If TypeOf depObj Is DataGridCell Then
                    While depObj IsNot Nothing And Not TypeOf depObj Is DataGridRow
                        depObj = VisualTreeHelper.GetParent(depObj)
                    End While
                    Dim dgGridRow As DataGridRow = depObj
                    Dim RowView As DataRowView = dgGridRow.Item
                    Dim Row As DataRow = RowView.Row
                    Dim i As Integer = FoundResultsTable.Rows.IndexOf(Row)
                    If e.ChangedButton = MouseButton.Right Then
                        ContextMenuRowId = i
                        dagSearch.ContextMenu = dagSearchContextMenu
                    ElseIf e.ChangedButton = MouseButton.Left Then
                        FoundResults(i).Load = Not FoundResults(i).Load
                        FoundResultsTable.Rows(i).Item("Load") = FoundResults(i).Load
                    End If
                End If
            End If
        End If
    End Sub

    Private Sub dagSearchContextMenuSongOnGrooveshark_Click(ByVal sender As Object, ByVal e As MouseButtonEventArgs)
        Dim tempSong As SearchArtist.SearchArtistResult = FoundResults(ContextMenuRowId).Result
        Call ClearThread(SearchThread)
        BlockSearchButtons(Skin.getLanguageText("LangSongOnGroovesharkLoad", "Loading") & " """ + tempSong.SongName + """...")
        SearchThread = New Thread(New ParameterizedThreadStart(AddressOf DoSongOnGrooveshark))
        SearchThread.Start(tempSong)
    End Sub

    Private Sub dagSearchContextMenuGetBitrate_Click(sender As Object, e As MouseButtonEventArgs)
        Call ClearThread(SearchThread)
        SearchThread = New Thread(New ParameterizedThreadStart(AddressOf SetSingleBitrateFromGrid))
        SearchThread.Start(ContextMenuRowId)
    End Sub

    Private Sub dagSearchContextMenuAlbumResults_Click(ByVal sender As Object, ByVal e As MouseButtonEventArgs)
        'MessageBox.Show("Album Search: " & ContextMenuRowId)
        Dim tempSong As SearchArtist.SearchArtistResult = FoundResults(ContextMenuRowId).Result
        Call ClearThread(SearchThread)
        BlockSearchButtons(Skin.getLanguageText("LangSearchingAlbum", "Searching for album") & " """ + tempSong.AlbumName + """...")
        SearchThread = New Thread(New ParameterizedThreadStart(AddressOf DoSearchForAlbum))
        SearchThread.Start(tempSong)
    End Sub

    Private Sub dagSearchContextMenuArtistResults_Click(ByVal sender As Object, ByVal e As MouseButtonEventArgs)
        'MessageBox.Show("Artist Search: " & ContextMenuRowId)
        Dim tempSong As SearchArtist.SearchArtistResult = FoundResults(ContextMenuRowId).Result
        Call ClearThread(SearchThread)
        BlockSearchButtons(Skin.getLanguageText("LangSearchingArtist", "Searching for artist") & " """ + tempSong.ArtistName + """...")
        SearchThread = New Thread(New ParameterizedThreadStart(AddressOf DoSearchForArtist))
        SearchThread.Start(tempSong)
    End Sub

    Private Sub dagSearchContextMenuSelect_Click(ByVal sender As Object, ByVal e As MouseButtonEventArgs)
        For Each element As DataRowView In dagSearch.SelectedItems
            Dim i As Integer = FoundResultsTable.Rows.IndexOf(element.Row)
            FoundResults(i).Load = True
            FoundResultsTable.Rows(i).Item("Load") = True
        Next
    End Sub

    Private Sub dagSearchContextMenuDeselect_Click(ByVal sender As Object, ByVal e As MouseButtonEventArgs)
        For Each element As DataRowView In dagSearch.SelectedItems
            Dim i As Integer = FoundResultsTable.Rows.IndexOf(element.Row)
            FoundResults(i).Load = False
            FoundResultsTable.Rows(i).Item("Load") = False
        Next
    End Sub

    Private Sub btnImportBatch_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        Dim openDialog As New System.Windows.Forms.OpenFileDialog
        openDialog.AutoUpgradeEnabled = True
        openDialog.CheckFileExists = True
        openDialog.CheckPathExists = True

        openDialog.Filter = "Textfiles(*.txt)|*.txt|All files(*.*)|*.*"
        If openDialog.ShowDialog() = Forms.DialogResult.OK Then
            txtBatchSearch.Text = File.ReadAllText(openDialog.FileName)
        End If
    End Sub

    Private Sub mniGoToDownloadDir_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        Dim ProcessInfo As New ProcessStartInfo("explorer")
        ProcessInfo.Arguments = myConfig.Settings.DownloadDir
        Process.Start(ProcessInfo)
    End Sub

    Private Sub btnProxyTest_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        With myConfig.Settings
            .Proxy = txtProxy.Text
            .ProxyUser = txtProxyUser.Text
            .ProxyPass = txtProxyPass.Password
            grooveClient = Nothing
            Call setGrooveClient()
            Call mniReconnect_Click(Nothing, Nothing)
        End With
    End Sub

    Private FilterThread As Thread
    Private FilterIsBlocked As Boolean

    Private Sub DoFilter(ByVal Text As String)
        Dim view As New DataView(FoundResultsTable)

        Dim FilterString As String = ""

        For Each col As DataColumn In FoundResultsTable.Columns
            If col.DataType Is GetType(String) Then
                FilterString += col.ColumnName & " LIKE " & "'*" & Text & "*'" & " OR "
            End If
        Next

        If FilterString.EndsWith(" OR ") Then
            FilterString = FilterString.Substring(0, FilterString.Length - 4)
        End If

        'AddDebug(FilterString)

        view.RowFilter = FilterString

        Thread.Sleep(500)
        SetFilterView(view)
    End Sub
    Private Sub SetFilterView(ByVal view As DataView)
        If Me.Dispatcher.Thread Is Thread.CurrentThread Then
            dagSearch.ItemsSource = view
        Else
            Me.Dispatcher.Invoke(New ParameterizedThreadStart(AddressOf SetFilterView), view)
        End If
    End Sub
    Private Sub txtResultFilter_TextChanged(ByVal sender As Object, ByVal e As TextChangedEventArgs)
        Dim text As String = txtResultFilter.Text.Replace("'", """")

        Call ClearThread(FilterThread)
        FilterThread = New Thread(New ParameterizedThreadStart(AddressOf DoFilter))
        FilterThread.Start(text)
    End Sub

    Private Sub mniCommandLine_Click(sender As Object, e As RoutedEventArgs)
        ShowCommandLineHelp()
    End Sub

    Private Sub mniDebugMode_Click(sender As Object, e As RoutedEventArgs)
        Dim ShellEx As New ProcessStartInfo()
        ShellEx.UseShellExecute = True
        ShellEx.FileName = System.Reflection.Assembly.GetExecutingAssembly.GetModules()(0).FullyQualifiedName
        ShellEx.Arguments = "-debug"
        Process.Start(ShellEx)
        Me.Close()
    End Sub

    Private Sub mniSupport_Click(sender As Object, e As RoutedEventArgs)
        Dim ShellEx As New ProcessStartInfo()
        ShellEx.UseShellExecute = True
        ShellEx.FileName = "http://forum.scilor.com"
        Process.Start(ShellEx)
    End Sub

    Private Sub notifyIcon_Click(sender As Object, e As EventArgs)
        If Me.ShowInTaskbar Then
            Me.Hide()
        Else
            Me.Show()
        End If
        Me.ShowInTaskbar = Not Me.ShowInTaskbar
    End Sub

    Public Sub UpdateGrid(RowId As Integer)
        If Me.Dispatcher.Thread Is Thread.CurrentThread Then
            FoundResultsTable.Rows.RemoveAt(RowId)
            FoundResultsTable.Rows.InsertAt(EnhancedResultGrid.CreateEnhancedTableRow(FoundResultsTable, FoundResults(RowId)), RowId)
            FoundResultsTable.AcceptChanges()

            dagSearch.ItemsSource = FoundResultsTable.AsDataView()
        Else
            Me.Dispatcher.Invoke(New IntegerDelegate(AddressOf UpdateGrid), RowId)
        End If
    End Sub

    Public Sub SetSingleBitrateFromGrid(RowId As Integer)
        Dim thread As New Thread(New ParameterizedThreadStart(AddressOf SetSingleBitrate))
        thread.Start(FoundResults(RowId).Result)
        If thread.Join(grooveBitRateClient.TimeOut) Then
            FoundResults(RowId).Reload()
            UpdateGrid(RowId)
        Else
            AddDebug(Skin.getLanguageText("LangBitrateFailed", "Loading Bitrate failed."))
        End If
    End Sub
    Public Sub SetSingleBitrate(Song As SearchArtist.SearchArtistResult)
        Try
            AddDebug(Skin.getLanguageText("LangBitrateLoading", "Loading Bitrate..."))
            Song.BitRate = grooveBitRateClient.GetSongBitrate(Song.SongID, Song.ArtistID)
            AddDebug(Skin.getLanguageText("LangBitrate", "Bitrate") & ": " & Song.ArtistName & " - " & Song.Name & ": " & Song.BitRate & "bps")
        Catch ex As Exception
            AddDebug(Skin.getLanguageText("LangBitrate", "Bitrate") & ": " & ex.Message)
        End Try
    End Sub
    Public Sub SetSongBitrates(ByRef SongList As List(Of SearchArtist.SearchArtistResult), Optional MaxBlock As Integer = 10, Optional Start As Integer = 0)
        Dim threads As New List(Of Thread)

        For i As Integer = Start To Math.Min(Start + MaxBlock - 1, SongList.Count - 1)
            Dim Song As SearchArtist.SearchArtistResult = SongList(i)
            Dim thread As New Thread(New ParameterizedThreadStart(AddressOf SetSingleBitrate))
            thread.Start(Song)
            threads.Add(thread)
        Next
        For Each thread As Thread In threads
            thread.Join(30000 / MaxBlock)
        Next
        For Each thread As Thread In threads
            If thread.IsAlive Then thread.Abort()
        Next
        If Math.Min(Start + MaxBlock - 1, SongList.Count - 1) = Start + MaxBlock - 1 Then
            'SetSongBitrates(SongList, MaxBlock, Start + MaxBlock)
        End If
    End Sub

End Class
